/*
   This recursive method maxR has O(n) runtime but
   it has O(ln(n)) depth of recursion.
*/

public class MaxR_2
{
   public static int maxR(int[] a, int lo, int hi, String s)
   {
      System.out.println(s + "maxR with lo=" + lo + ", hi=" + hi);
      int result;
      if (lo == hi)
      {
         result = a[lo];
      }
      else
      {  // split the array into two halves, take the max of each half's max
         result = max2( maxR(a, lo, (lo+hi)/2, s+" "), maxR(a, 1+(lo+hi)/2, hi, s+" ") );
      }
      System.out.println(s + "return " + result);// comment this out, and you will
      return result;                             // see a tree structure of calls
   }

   public static int max2(int x, int y)
   {
      if (x >= y) return x; else return y;
   }

   public static void main( String[] args )
   {
      int[] a = new int[32];

      for (int i = 0; i < a.length; i++)
         a[i] = (int)(1000*Math.random());

      int r = maxR(a, 0, a.length-1, "");
      System.out.println("max = " + r);
   }
}
