
-- flatten a list of lists
-- flatten [[1,2,3], [6,5,4], [], [5]] ==> [1, 2, 3, 6, 5, 4, 5]
flatten :: [[a]] -> [a]
flatten [] = []
flatten ([]:rest) = flatten rest
flatten ((x:xs):rest) = x : flatten (xs:rest)


-- flatten [[1, 2], [3], [4]]
-- ==> 1 : flatten [[2], [3], [4]]
-- ==> 1 : 2 : flatten [[], [3], [4]]
-- ==> 1 : 2 : flatten [[3], [4]]
-- ==> 1 : 2 : 3 : flatten [[], [4]]
-- ==> 1 : 2 : 3 : flatten [[4]]
-- ==> 1 : 2 : 3 : 4: flatten [[]]
-- ==> 1 : 2 : 3 : 4: flatten []
-- ==> 1 : 2 : 3 : 4 : []
-- ==> 1 : 2 : 3 : [4]
-- ==> 1 : 2 : [3, 4]
-- ==> 1 : [2, 3, 4]
-- ==> [1, 2, 3, 4]


-- If you flatten a list of lists of lists, then you get a list of lists.
-- flatten [ [[1],[2],[3]], [[1,2],[3,4]], [[4]], [] ]  ==>  [[1],[2],[3],[1,2],[3,4],[4]]

-- If you twice flatten a list of lists of lists, then you get a list.
-- flatten (flatten [ [[1],[2],[3]], [[1,2],[3,4]], [[4]], []])  ==>  [1,2,3,1,2,3,4,4]


-- What happens if you replace the last pattern with this? Why?
-- flatten ((x:xs):rest) = x : flatten rest

-- What would happen if you deleted the second (middle) pattern? Why?


-- In the Haskell library, flatten is really called concat.
-- concat [[1,2,3], [6,5,4], [], [5]] ==> [1, 2, 3, 6, 5, 4, 5]
